unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  BGRAGraphicControl, BGRABitmap, BGRABitmapTypes, BCTypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    edH: TEdit;
    edH1: TEdit;
    edW: TEdit;
    edW1: TEdit;
    GCMap: TBGRAGraphicControl;
    GCRafale: TBGRAGraphicControl;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LabelMap: TLabel;
    LabelRafale: TLabel;
    LabelX: TLabel;
    LabelY: TLabel;
    MAP: TLabel;
    MAP1: TLabel;
    TbMap: TTrackBar;
    TbRafale: TTrackBar;
    tbX: TTrackBar;
    tbY: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure GCMapRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure GCRafaleRedraw(Sender: TObject; Bitmap: TBGRABitmap);
    procedure TbMapChange(Sender: TObject);
    procedure TbRafaleChange(Sender: TObject);
    procedure tbXChange(Sender: TObject);
    procedure tbYChange(Sender: TObject);
  private
  var
    Xpos, Ypos: integer;
  public
    { public declarations }
    bmp: TBGRABitmap;
    bmp2: TBGRABitmap;
    Origine : TpointF;

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.GCMapRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  //========================================================
  // Affichage du déplacement horizontal ou vertical
  // L'angle de rotation est mis à zéro
  //========================================================
  Origine:=Tpointf.Create(Xpos+220,Ypos+308); //(2048,2048)
// bmp:= Bitmap.FilterRotate(Origine,tbMap.Position,false);
   Bitmap.PutImageAngle(-Xpos, -Ypos, bmp.FilterRotate(Origine,tbMap.Position,false), 0, rfHalfCosine, 0, 0);
end;

procedure TForm1.GCRafaleRedraw(Sender: TObject; Bitmap: TBGRABitmap);
begin
  //=============================================================
  //                      Rotation du Rafale
  //=============================================================
  Bitmap.PutImageAngle(Bitmap.Width / 2 - 0.5, Bitmap.Height / 2 - 0.5, bmp2,
  TbRafale.Position, rfHalfCosine, bmp2.Width / 2 - 0.5, bmp2.Height / 2 - 0.5);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  bmp := TBGRABitmap.Create('Korea.jpg');
  bmp2 := TBGRABitmap.Create('Rafale.png');

  //=======================================
  // Affichage des dimensions
  // de l'écran d'affichage et de la carte
  edW.Text := IntToStr(GCMap.Height);
  edH.Text := IntToStr(GCMap.Width);
  edW1.Text := IntToStr(bmp.Height);
  edH1.Text := IntToStr(bmp.Width);
  //========================================

  // Coordonnées du Rafale
  Xpos := tbX.Position;
  Ypos := tbY.Position;

  LabelX.Caption := IntToStr(Xpos);
  LabelY.Caption := IntToStr(Ypos);

  // Mise à jour de l'afffichage
  GCMap.RedrawBitmap;
  GCRafale.RedrawBitmap;
end;

procedure TForm1.TbMapChange(Sender: TObject);
begin
  GCMap.RedrawBitmap;
end;

procedure TForm1.tbYChange(Sender: TObject);
begin
  //=============================================================
  //               Déplacement vertical (axe Y)
  //=============================================================
  // Coordonnées sur la carte
  Xpos := tbX.Position;
  ;
  Ypos := tbY.Position;
  LabelX.Caption := IntToStr(Xpos);
  LabelY.Caption := IntToStr(Ypos);

  // Mise à jour de l'afficahge
  GCMap.RedrawBitmap;
end;

procedure TForm1.tbXChange(Sender: TObject);
begin
  //=============================================================
  //               Déplacement horizontal (axe X)
  //=============================================================
  Xpos := tbX.Position;
  Ypos := tbY.Position;
  LabelX.Caption := IntToStr(Xpos);
  LabelY.Caption := IntToStr(Ypos);

  // Mise à jour de l'afficahge
  GCMap.RedrawBitmap;
end;

procedure TForm1.TbRafaleChange(Sender: TObject);
begin
  LabelRafale.Caption := IntToStr(TbRafale.Position);// Cap du Rafale (en degrés)

  // Mise à jour de l'afficahge
  GCRafale.RedrawBitmap;
end;

end.
